package ru.amse.smyshlyaev.grapheditor.graph;


public class Edge extends LabelOwner implements IEdge {
	private ISelectableVertex myStart;
	private ISelectableVertex myEnd;
	
	public Edge() {
		this(null, null, "");
	}
	
	public Edge(ISelectableVertex start, ISelectableVertex end, String label) {
		super(label);
		
		myStart = start;
		myEnd = end;
	}
	
	public Edge(ISelectableVertex start, ISelectableVertex end) {
		this(start, end, "");
	}

	public ISelectableVertex getStart() {
		return myStart;
	}

	public ISelectableVertex getEnd() {
		return myEnd;
	}
	
	public void setStart(ISelectableVertex v) {
		if (myStart != null) {
    		myStart.removeEdge(this);
		}
		
		myStart = v;
		
		if (myStart != null) {
    		myStart.addEdge(this);
		}
	}
	
	public void setEnd(ISelectableVertex v) {
		if (myEnd != null) {
    		myEnd.removeEdge(this);
		}
		
		myEnd = v;
		
		if (myEnd != null) {
    		myEnd.addEdge(this);
		}
	}
}