package ru.amse.smyshlyaev.grapheditor.ui.tool.defaulttool;

import java.awt.event.*;
import java.awt.Graphics;

import ru.amse.smyshlyaev.grapheditor.graph.*;
import ru.amse.smyshlyaev.grapheditor.ui.JGraphComponent;
import ru.amse.smyshlyaev.grapheditor.ui.tool.ITool;


/*package*/ class DefaultlVertexTool extends VertexMarker
                      implements ITool {
	private Vertex myVertex;
	private int myCurrentX;
	private int myCurrentY;
	private boolean myShouldClearVertices;
	private boolean myShouldRemoveVertex;

	public DefaultlVertexTool(JGraphComponent component) {
		super(component);

		myVertex = null;
		myShouldClearVertices = false;
		myShouldRemoveVertex = false;
	}

	public void paint(Graphics gc) {
		super.paint(gc);
	}

	public Vertex getVertex() {
		return myVertex;
	}

	public void setVertex(Vertex v) {
		myVertex = v;
	}
	
	public void mousePressed(MouseEvent e) {
        myCurrentX = e.getX();
	    myCurrentY = e.getY();

	    if ((e.getModifiersEx() &
	    		MouseEvent.CTRL_DOWN_MASK) != 
			        MouseEvent.CTRL_DOWN_MASK) {
	    	if (myComponent.getMarkedVertices().contains(
	    			myVertex
	    		)) {
    	        myShouldClearVertices = true;
    	        return;
    	    } else {
    	    	myComponent.clearMarkedVertices();
    	    }
	    } else {
	    	if (myComponent.getMarkedVertices().contains(
	    			myVertex
        		)) {
	    		myShouldRemoveVertex = true;
	    		return;
	    	}
	    }
	    	
		myComponent.addMarkedVertex(myVertex);
    	myComponent.repaint();
	}

	public void mouseReleased(MouseEvent e) {
		if (myShouldRemoveVertex) {
			myComponent.removeMarkedVertex(myVertex);
	    	myComponent.repaint();

			myShouldRemoveVertex = false;
			return;
		}
		
		if (myShouldClearVertices) {
			myComponent.clearMarkedVertices();
			myComponent.addMarkedVertex(myVertex);
	    	myComponent.repaint();

			myShouldClearVertices = false;
		}
	}

	public void mouseDragged(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();

		myShouldClearVertices = false;
		myShouldRemoveVertex = false;
		
		for (IVertex v : myComponent.getMarkedVertices()) {
			v.addX(x - myCurrentX);
    		v.addY(y - myCurrentY);
		}

		myCurrentX = x;
		myCurrentY = y;

		myComponent.repaint();
	}
}