package ru.amse.smyshlyaev.grapheditor.ui.tool.defaulttool;

import java.awt.*;
import java.util.List;

import ru.amse.smyshlyaev.grapheditor.graph.*;
import ru.amse.smyshlyaev.grapheditor.ui.tool.*;
import ru.amse.smyshlyaev.grapheditor.ui.JGraphComponent;


/*package*/ class VertexMarker extends ToolAdapter
                           implements ITool {
	protected final JGraphComponent myComponent;
	
	public VertexMarker(JGraphComponent component) {
		myComponent = component;
	}
	
	public void paint(Graphics gc) {
		List<ISelectableVertex> vertices =
			myComponent.getMarkedVertices();
		
		Rectangle rectangle;
		
		Graphics2D g2d = (Graphics2D) gc;
		
		for (ISelectableVertex v : vertices) {
			rectangle = v.getSelectionRectangle(g2d);

			gc.drawRect(
					rectangle.x,
					rectangle.y,
					rectangle.width,
					rectangle.height
	    	);						
		}
	}
}